; morzecA.asm: elkey program, potmteres sebessglltssal az
; "elkey c" krtyhoz. Kommentek 2014-bl.

; V1.0:	Alapvltozat

	DEVICE	PIC12C509, xRC_OSC,WDT_OFF,PROTECT_OFF, MCLR_OFF


; Konstansok

DL	=	64	; Alaptem, 64x62 utasts
SOUND0	=	0EFH	; Hang 0. fzis le (rb.0)
SOUND1	=	0DFH	; Hang 1. fzis le (rb.1)
OUTCMK  =       0CBH    ; I/O struktra jelidben
OUTCSP  =       0EBH	; I/O struktra sznetben
INMASK	=	3       ; gyorsbillenty bitek
;SPT1	=	138	; a space bels ciklusa (138)
;MKT1	=	139	; a mark bels ciklusa (139)
ASCLEN	=	12	; az ASCII szveg hossza

; Vltozk

	ORG	8H

; Bitenknt is hasznlt regiszterek

STST	DS	1	; Start Status
INV	=	STST.3	; Invertlt kimenet opci
OUTST	DS	1	; Kimenet httrregiszter
MOD	=	OUTST.2	; Kapcsol (modull) bit
ONH	=	OUTST.4	; nhang kapcsol
S0	=	RB.4	; Hang 0. fzis definci
S1	=	RB.5	; Hang 1. fzis definci
PONT	=	RB.0	; Pont bemenet definci
VONAS	=	RB.1	; Vons bemenet definci
SBUF	DS	1	; Adpuffer minden mdban
HANGOS	=	SBUF.6  ; Modul als bitje
HOSSZU	=	SBUF.7	; Modul fels bitje
SB1	DS	1       ; Kbd modulpuffer
M0HAN	=	SB1.2	; Els szint, hangos bit
M0HOS	=	SB1.3	; Els szint, hossz bit
M1HAN	=	SB1.6   ; Msodik ...
M1HOS	=	SB1.7
FLAGS	DS	1	; Vegyes jelzbitek
GOTTI	=	FLAGS.0	; j ti rkezett
GOTTA	=	FLAGS.1	; j t rkezett
BIT	=	FLAGS.2	; Ez a verzi nem hasznlja
VAN	=	FLAGS.3	; Van leadnival
ASY	=	FLAGS.4	; Tbbedik sznet megy
TOG	=	FLAGS.5	; Flciklusvlaszt
EXEN	=	FLAGS.6	; "Exit enabled" flag
EXIT	=	FLAGS.7 ; "Exit request" flag
RBBUF	DS	1	; Bemenet puffer
UJTI	=	RBBUF.0
UJTA	=	RBBUF.1
KBBUF	DS	1	; Elz bemenet puffer
OLDTI	=	KBBUF.0
OLDTA	=	KBBUF.1
SBP	DS	1       ; Adpuffer-pointer
JEL	DS	1	; Jelhossz adsnl

; Bitenknt nem rtelmezett regiszterek

ASCBUF	DS	1	; ASCII karakter puffer
ASCPTR	DS	1	; ASCII (ROM) pointer
MCNT	DS	1	; Byteszmll
MODCNT	DS	1	; Modulszmll (4/byte)
CNTR	DS	1	; Szmll (pontid)
DOTLEN	DS	1	; Ponthosszsg (x0,625 ms)
DCNT	DS	1	; Alapidzts szmllja
SPCNT	DS	1       ; Space-szmll als
SPCNT1	DS	1	; Space-szmll fels
PCNT	DS	1	; Pad-szmll


; Reset vektor

	ORG	0
	MOV	OSCCAL,W
	JMP	START


	ORG	8

; Itt kezddik a kdtbla. A nem ltez karakterek dupla nullt
; adnak vissza, amibl adsban szablyos space lesz, mert mindkt
; nullnak az els rvid res modulja megy ki.

LUPNUM	JMP	PC+W
	RETW	00H, 0		; space
        RETW    0DDH, 0F0H      ; ! (NEM SZABVNYOS)
	RETW	75H, 0D0H	; "
        RETW    0, 0            ; # (nincs)
        RETW    57H, 54H        ; $ (jav!)
	RETW	0, 0		; % (nincs)
	RETW	0, 0		; & (nincs)
	RETW	7FH, 0D0H	; '
        RETW    0DFH, 70H       ; ( (jav!)
        RETW    0DFH, 70H       ; ) (jav, ua, mint a nyit)
        RETW    77H, 40H        ; * (jav)
	RETW	0F5H, 0F0H	; ,
	RETW	0D5H, 70H	; -
	RETW	77H, 70H	; .
	RETW	0D7H, 40H	; /

	RETW	0FFH, 0C0H	; 0
	RETW	7FH, 0C0H	; 1
	RETW	5FH, 0C0H	; 2
	RETW	57H, 0C0H	; 3
	RETW	55H, 0C0H	; 4
	RETW	55H, 40H	; 5
	RETW	0D5H, 40H	; 6
	RETW	0F5H, 40H	; 7
	RETW	0FDH, 40H	; 8
	RETW	0FFH, 40H	; 9
	RETW	0FDH, 50H	; :
	RETW	0DDH, 0D0H	; ;
	RETW	0, 0		; < (nincs)
	RETW	0D5H, 0C0H	; =
	RETW	0, 0		; > (nincs)
	RETW	5FH, 50H	; ?

; Alfa kdtbla. A jtkszably itt ms, egy alfa karakter max. 4
; rtelmes modult tartalmaz. Az esetleges tllg betvgjelt a
; gpad automatikusan hozzadja. A nem hasznlt karakterek
; FF-ben maradtak, teht tdefinilhatk. Addig is 4 t-t adnak.

LUPAL	AND	W,#1FH
	JMP	PC+W
	RETW	0FFH		; @ (nincs)
	RETW	70H 		; A
	RETW	0D5H 		; B
	RETW	0DDH 		; C
	RETW	0D4H 		; D
        RETW    40H             ; E
	RETW	5DH 		; F
	RETW	0F4H 		; G
	RETW	55H 		; H
	RETW	50H 		; I
	RETW	7FH 		; J
	RETW	0DCH 		; K
	RETW	75H 		; L
	RETW	0F0H 		; M
	RETW	0D0H 		; N
	RETW	0FCH 		; O
	RETW	7DH 		; P
	RETW	0F7H 		; Q
	RETW	74H 		; R
	RETW	54H 		; S
	RETW	0C0H 		; T
	RETW	5CH 		; U
	RETW	57H 		; V
	RETW	7CH 		; W
	RETW	0D7H 		; X
	RETW	0DFH 		; Y
	RETW	0F5H 		; Z
	RETW	0FFH		; [ (nincs, lehetne )
	RETW	0FFH 		; \ (nincs)
	RETW	0FFH 		; ] (nincs, lehetne )
	RETW	0FFH 		; ^ (nincs)
	RETW	0FFH 		; _ (nincs)

; Itt az alap kdtbla vge. Lenne mg ngy kezetes bet, s
; nhny specilis jel, de ezeket a gpad jelenleg nem kezeli.
; Az az egyik baj, hogy egyes ASCII betk nem frnek be 4 modulba.

; Ez egy ASCII string. Bekapcsolskor nyomva tartott ti hatsra
; megy adsba.

LUPASC	JMP	PC+W
	RETW	'ELKEY C V1.1'


DEL600	MOV	W,#149		;
DELW	MOV	DCNT,W		; w-arnyos belpsi pont
:L1	NOP                     ; 4 temes bels ciklus
	DJNZ	DCNT,:L1
	RET


; Jel init. Vezrli a billentyz kimenetet, indtja az nhangot.

MKINIT	SETB	MOD
	SNB	INV
	CLRB	MOD
	setb	onh
	MOV	W,OUTST
	MOV	RB,W
	RET


; Sznet init. Lelltja a billentyz kimenetet, bemenetet csinl az
; nhang kimenetekbl a ktgombos sebessglltshoz.

SPINIT	CLRB	MOD
	SNB	INV
	SETB	MOD
	CLRB	ONH
	MOV	W,OUTST
	MOV	RB,W
	RET

; Modul adst vgz szubrutin. Elemi sznetek ellltsra is
; alkalmas (norml zemmdban). Aszinkron sznetek megvalstsra
; elksztve.

TXBUF	JNB	HANGOS,SPACE	; Elemi sznet lehetsge

MARK	MOV	CNTR,#DL	; Gpad belpsi pontja
	SNB	HOSSZU          ; Hosszbellts
	SETB	cntr.7
	SNB	HANGOS
	CALL	MKINIT		; Az ad billentyzse (jel)
	SETB	TOG		; Kezd flciklus kijellse
:L1	CALL	TGL		; Bemenetkezels s nhang
	MOV	PCNT,W		; Hosszkiegyenlts
	DJNZ	PCNT,$
	nop
	JMP	$+1
	JMP	$+1
	DJNZ	CNTR,:L1
	MOV	W,#8
	SNB	HOSSZU
	or	W,#16
	call	delw
	CLR	SPCNT1
	MOV	CNTR,#DL
	JMP	SPACEM

SPACE	MOV	CNTR,#DL
	CLRB	C
	SNB	HOSSZU
	rl	cntr
SPACEM	CALL	SPINIT		; Adbillentyzs (sznet)
	SETB	TOG
SPACE1	MOV	CNTR,DOTLEN
SL1	CALL	TGL
	MOV	PCNT,W
	DJNZ	PCNT,$
	nop
	SNB	EXEN		; Aszinkron kiszlls
	SB	EXIT		; feltteleit vizsgl sorok
	JMP	SK1             ; Itt nem szll ki
	MOV	CNTR,#1		; Itt kiszll
SK1	DJNZ	CNTR,SL1
	INC	SPCNT
	SNZ
	INC	SPCNT1
	RET

; Sznetvgi kirtkels (kzelt hosszkiegyenltssel). Ez csak a
; gyorsbillenty kezelshez kell (ismtls, jambimatik), gpad
; zemmdban nem fut.

EVAL	TEST	SBP
	JNZ	SKREP
	TEST	RBBUF
	JZ	NONE
	SETB	M0HAN
	INC	SBP
	SNB	UJTI
	SB	UJTA
	JMP	SINGLE
	SNB	HOSSZU
	CLRB	M0HOS
	SB	HOSSZU
	SETB	M0HOS
	SETB	VAN
	NOP
	RET
SINGLE	SNB	UJTA
	SETB	M0HOS
	SNB	UJTI
	CLRB	M0HOS
	SETB	VAN
	RET
SKREP	CLRB	GOTTI
	CLRB	GOTTA
	SETB	VAN
	NOP
	JMP	$+1
	JMP	$+1
	JMP	$+1
	JMP	$+1
	JMP     SINGLE+5      ; return
NONE	CLRB	VAN
	JMP	SKREP+5       ; kiegyenlts folyt.

; A billentyzetkezels mr nem foglalkozik az nhanggal.
; Kiss trkks (visszatrs utni) hosszkiegyenltse szinte tkletes.

TGL	JB	TOG,TGL1

; debounce 0 flciklus
TGL0	SETB	TOG
tSK1	MOV	W,/RB
	AND	W,#INMASK
	MOV	W,RBBUF-W
	SZ
	RETW	14
	NOP
	SNB	SBP.1
	RETW	13
	SB	GOTTI
	SNB	OLDTI
	JMP	CHKTAP
	SB	UJTI
	JMP	CHKTAP+1
	SETB	GOTTI
	INC	SBP
	SETB	EXIT
	SB	ASY
	CLRB	EXIT
	JB	SBP.1,WTI
	SETB	M0HAN
	CLRB	M0HOS
	JMP	CHKTA
WTI	SETB	M1HAN
	CLRB	M1HOS
	NOP
CHKTA	SNB	SBP.1
	RETW	7
	SB	GOTTA
	SNB	OLDTA
	JMP	KBENDP
	SB	UJTA
	JMP	KBENDP+1
	SETB	GOTTA
	INC	SBP
	SETB	EXIT
	SB	ASY
	CLRB	EXIT
	JB	SBP.1,WTA
	SETB	M0HAN
	SETB	M0HOS
	JMP	KBEND
WTA	SETB	M1HAN
	SETB	M1HOS
	NOP
KBEND	MOV	KBBUF,RBBUF
	RETW	1
CHKTAP	JMP	$+1
	JMP	$+1
	JMP	$+1
	JMP	$+1
	JMP	$+1
	JMP	CHKTA
KBENDP	JMP	$+1
	JMP	$+1
	JMP	$+1
	JMP	$+1
	JMP	$+1
	JMP	KBEND
TSK1P	JMP	TSK1

; debounce 1 flciklus
TGL1	CLRB	TOG
TSK0	MOV	W,/RB
	AND	W,#INMASK
	MOV	RBBUF,W
	RETW	14
TSK0P   JMP     TSK0

; ASCII string adsa. Gpad program ROM-ban trolt ASCII szveghez. A
; ktszint stack nem engedte meg, hogy szubrutin legyen belle.

SNDASC  CLR     ASCPTR          ; els karakterre mutasson
        MOV     MCNT,#ASCLEN    ; visszaszmll=karakterszm
NEXTM	MOV	W,ASCPTR
	CALL	LUPASC
        MOV     ASCBUF,W        ; aktulis karakter az ascii bufban
        CLRB    ASCBUF.5        ; tblzatnl nullaknt rtkelend
        JB      ASCBUF.6,ALFA   ; mert bet mez
        CLRB    C               ; innen szmjegy s jel mez, ahol
        RL      ASCBUF          ; egy jel kt bjt, gy a pointert
        MOV     W,ASCBUF        ; hasznlat eltt duplzni kell
        CALL    LUPNUM          ; ez beveszi az els bjtot
        MOV     SBUF,W          ; itt kerl sbuf-ba
        MOV     MODCNT,#4       ; 4 modulos ciklus incializlsa
NMOD0   CALL    MARK            ; a MARK leadja az els modult
        JNB     HANGOS,:SK0     ; ha res, a msodik ASCII jn
        RL      SBUF            ; ha nem, a kvetkez modul lp sbuf
        RL      SBUF            ; elejre s megy adsba
        DJNZ    MODCNT,NMOD0    ; amg a bjt el nem fogy       
:SK0    MOV     W,++ASCBUF      ; kvetkez bjt (4 modul) cmzse
        CALL    LUPNUM          ; kinyerse
        MOV     SBUF,W          ; leraksa
        MOV     MODCNT,#4       ; j ngymodulos adciklus init
NMOD1   CALL    MARK            ; (pont mint az elz)
	JNB	HANGOS,CONTM
	RL	SBUF
	RL	SBUF
	DJNZ	MODCNT,NMOD1
CONTM   INC     ASCPTR          ; kvetkez ASCII karakter
	DJNZ	MCNT,NEXTM
	CLR	SBUF
        JMP     NORM            ; ASCII leadva
ALFA    MOV     W,ASCBUF        ; (kiderlt, hogy bet)
	CALL	LUPAL
        MOV     SBUF,W          ; a 4 modul az alfa tblbl jn
; az ads ugyanolyan, de nincs msodik 4 modul, viszont ha a
; negyedik modul hangos, akkor kiegszl egy nma modullal.
	MOV	MODCNT,#4
NMOD2	CALL	MARK
	JNB	HANGOS,CONTM
	RL	SBUF
	RL	SBUF
	DJNZ	MODCNT,NMOD2
	CLR	SBUF
	CALL	MARK
	JMP	CONTM


; A fprogram persze megint a vgre maradt:

START	MOV	W,#0		; Konfigurls
	OPTION
	MOV	OUTST,#0FBH
	CLR	FLAGS		; Trlsek
	CLR	RBBUF
	CLR	KBBUF
	CLR	SBP
	CLR	SBUF
	CLR	SB1
	CLR	SPCNT1
	CALL	SPINIT		; Alapllapot
	CALL	DEL600		; 0,6 ms vrakozs
	MOV	W,/RB
	MOV	STST,W
	SNB	INV
	SETB	MOD
	MOV	RB,OUTST
	MOV	W,#OUTCSP
	TRIS	RB
	NOP
	JB	GPWUF,NORM	; (ha csiklandoztk, ugrik)
	MOV	DOTLEN,#DL	; Ha nem, sebessg=alapsebessg
	JNB	PONT,SNDASC	; s ha pont, azonostja magt,
	SB	VONAS		; ha vons, tmegy aszinkronba
	SETB	EXEN
NORM	MOV	JEL,#1		; Itt kezddik a fhurok egy
	CLR	SB1		; sznettel, amiben beolvas
	SETB	ASY		; Ez rvidthet lehetne
	CALL	SPACE1		; Adrutin egyik belpsi pontja
	JB	SPCNT1.7,STOP	; lmossgvizsglat
TXKL1	CALL	EVAL            ; Bels hurok, amg van mit adni
;	SNB	VAN
	JNB	VAN,NORM        ; Itt ugrik ki, ha mr nincs
TXKEY	SWAP    SB1             ; Segdpuffer pozcionls
	MOV	SBUF,SB1        ; trs az adpufferbe
	DEC	SBP             ; Pointerkezels
	SNB	SBP.7           ; Elvben mindig ugrik
	CLR	SBP             ; Elvben soha nem hajtja vgre
	CLRB	ASY             ; Az els sznet nem rvidthet
	CALL	TXBUF           ; Elemi adrutin hvsa
	JMP	TXKL1		; Bels hurok zrdik

STOP	MOV	W,/RB		; Altat
	AND	W,#INMASK
	JNZ	STOP
	SLEEP

; Itt a vge
